{mik 12/06/98 for parse line , used for mail merge}
unit Uparse;
interface
uses classes;
type
  TMyParser = class(tcomponent)
    private
      FieldSep: char;
      FLine: string;
      NumFields: byte;
      Index, Ct: array[0..255] of integer;
      function Getstr(n: byte): string;
			constructor Create( AParent : TComponent ); override;
    public
      property Sepchar: char read FieldSep write FieldSep;
      property count: byte read NumFields;
      property fields[n: byte]: string read Getstr; default;
      procedure Parse(const Line: string);
    end;

Procedure register;

implementation

procedure Register;
begin
  RegisterComponents('Mik', [TMyParser]);
end;

constructor TMyParser.Create( AParent : TComponent );
begin
  inherited Create(aParent);
  FieldSep:=' ';
  FLine:='';
  NumFields:= 0;
end;

function TMyParser.Getstr(n: byte): string;
  begin
  result := '';
  if n > NumFields then
    exit;
  if n = 0 then
    result := FLine
  else if n > 0 then
   begin
    dec(n); {0-based arrays!}
    if Index[n] > 0 then
      result := copy(FLine, index[n], ct[n]);
   end;
  end;

procedure TMyParser.Parse(const line: string);
var
 i,p : byte;
 s: string;
 s2 : string;
begin
 Fline := Line;
 s:= line;
 NumFields := 0;
 i := pos(FieldSep, s);
 while i > 0 do
   begin
    s2 := copy (s,1,i -1);
    if NumFields = 0 then
     index[NumFields] := 1
    else
     index[NumFields] := pos(s2,fline);
    ct[NumFields] := length(s2);
    delete(s,1,i);
    i := pos(FieldSep, s);
    inc(NumFields);
   end;
end;
end.
